<div class="container">
  <div *ngFor="let module of modulesWithDataModel; let i = index" class="box">

    <h3 class="subtitle is-3">{{ module.name }}</h3>
    <hr>

    <div class="columns">

      <!-- NAME -->
      <div class="column is-2">
        <div class="field">
          <div class="control">
            <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Name</label>
            <input class="input" type="text" [(ngModel)]="newCriteriasNames[i]">
          </div>
        </div>
      </div>
    </div>

    <div class="field">
      <div class="control">
        <label class="label">Description</label>
        <input class="input" type="text" [(ngModel)]="newCriteriasDescriptions[i]">
      </div>
    </div>

    <!-- FIRST SUB CRITERIA -->
    <div class="columns">

      <!--      WEIGHT -->
      <div class="column is-2">
        <div class="field">
          <div class="control">
            <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Weight</label>
            <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="weight"
                   [(ngModel)]="newEvaluationCriterias[i].subcriterias[0].weight">
          </div>
        </div>
      </div>

      <!-- OPERATOR -->
      <div class="column is-2">
      </div>

      <!-- KEY -->
      <div class="column is-2">
        <div class="field">
          <div class="control">
            <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Data to
              evaluate</label>
            <div class="select">
              <select [(ngModel)]="newEvaluationCriterias[i].subcriterias[0].key" (ngModelChange)="dataKeyChange(i, 0)">
                <option *ngFor="let data of getData(module)" [ngValue]="data">
                  {{ data }}
                </option>
              </select>
            </div>
          </div>
        </div>
      </div>

      <!-- COMPARATOR -->
      <div *ngIf="newEvaluationCriterias[i].subcriterias[0].key.length > 0" class="column is-2" style="text-align: center">
        <div class="field">
          <div class="control">
            <label class="label"
                   style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Comparator</label>
            <div class="select">
              <select [(ngModel)]="newEvaluationCriterias[i].subcriterias[0].compareSymbol">
                <option *ngFor="let comparator of getComparators(module, i, 0)" [ngValue]="comparator">
                  {{ comparator }}
                </option>
              </select>
            </div>
          </div>
        </div>
      </div>

      <!-- VALUE -->
      <div *ngIf="newEvaluationCriterias[i].subcriterias[0].key.length > 0" class="column is-2">
        <div class="field">
          <div class="control">

            <div [ngSwitch]="getDataType(newEvaluationCriterias[i].subcriterias[0].key, module)" class="field">

              <div *ngSwitchCase="'number'">
                <label class="label"
                       style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Value</label>
                <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="criteriaValue"
                       [(ngModel)]="newEvaluationCriterias[i].subcriterias[0].value">
              </div>

              <div *ngSwitchCase="'boolean'">
                <input [id]="newEvaluationCriterias[i].subcriterias[0].key" type="checkbox"
                       [name]="newEvaluationCriterias[i].subcriterias[0].key"
                       class="switch is-rounded is-primary form-control" checked
                       [(ngModel)]="newEvaluationCriterias[i].subcriterias[0].value">
                <label for="{{ newEvaluationCriterias[i].subcriterias[0].key }}" class="label">Value</label>
              </div>

              <div *ngSwitchCase="'string'">
                <label class="label">Value</label>
                <input class="input" type="text" [(ngModel)]="newEvaluationCriterias[i].subcriterias[0].value">
              </div>

            </div>

          </div>
        </div>

      </div>

      <!-- PLUS BUTTON -->
      <div
        *ngIf="newEvaluationCriterias[i].subcriterias[0].key.length > 0 && isLastSub(newEvaluationCriterias[i],newEvaluationCriterias[i].subcriterias[0])"
        class="column is-2">
        <label class="label"> <br/></label>

        <button [disabled]="addingAllowed(newEvaluationCriterias[i], i)" class="button is-success"
                (click)="addSubCriteria(newEvaluationCriterias[i])"
        ><span class="icon"><i class="fas fa-plus"></i></span>
        </button>
      </div>
      <div class="column" *ngIf="!isLastSub(newEvaluationCriterias[i],newEvaluationCriterias[i].subcriterias[0])"></div>

    </div>

    <!-- END FIRST SUB CRITERIA -->

    <!-- TEMPLATE SUB CRITERIA -->

    <div *ngFor="let sub of newEvaluationCriterias[i].subcriterias| slice:1;  let j=index" class="columns">


      <!--      WEIGHT -->
      <div class="column is-2">
        <div class="field">
          <div class="control">
            <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Weight</label>
            <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="weight"
                   [(ngModel)]="newEvaluationCriterias[i].subcriterias[j+1].weight">
          </div>
        </div>
      </div>

      <!-- OPERATOR -->
      <div class="column is-2">
        <div class="field">
          <div class="control">
            <label class="label"
                   style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Operator Type</label>
            <div class="select">
              <select [(ngModel)]="newEvaluationCriterias[i].operators[j].type">
                <option value="AND">
                  AND
                </option>
                <option value="OR">
                  OR
                </option>
              </select>
            </div>
          </div>
        </div>
      </div>

      <!-- KEY -->
      <div *ngIf="newEvaluationCriterias[i].operators[j].type.length > 0" class="column is-2">
        <div class="field">
          <div class="control">
            <label class="label" style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Data to
              evaluate</label>
            <div class="select">
              <select [(ngModel)]="sub.key" (ngModelChange)="dataKeyChange(i, j+1)">
                <option *ngFor="let data of getData(module)" [ngValue]="data">
                  {{ data }}
                </option>
              </select>
            </div>
          </div>
        </div>
      </div>

      <!--      EMPTY OPERATOR-->
      <div *ngIf="newEvaluationCriterias[i].operators[j].type.length == 0" class="column is-2">
      </div>


      <!-- COMPARATOR -->
      <div *ngIf="sub.key.length > 0" class="column is-2">
        <div class="field">
          <div class="control">
            <label class="label"
                   style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Comparator</label>
            <div class="select">
              <select [(ngModel)]="sub.compareSymbol">
                <option *ngFor="let comparator of getComparators(module, i, j+1)" [ngValue]="comparator">
                  {{ comparator }}
                </option>
              </select>
            </div>
          </div>
        </div>
      </div>

      <!--      EMPTY OPERATOR-->
      <div *ngIf="sub.key.length == 0" class="column is-2">
      </div>

      <!-- VALUE -->
      <div *ngIf="sub.key.length > 0" class="column is-2">
        <div class="field">
          <div class="control">

            <div [ngSwitch]="getDataType(sub.key, module)" class="field">

              <div *ngSwitchCase="'number'">
                <label class="label"
                       style="overflow-x: hidden; white-space: nowrap; text-overflow: ellipsis">Value</label>
                <input class="input" type="number" min="0" oninput="validity.valid||(value='');" name="criteriaValue"
                       [(ngModel)]="sub.value">
              </div>

              <div *ngSwitchCase="'boolean'">
                <input [id]="sub.key" type="checkbox"
                       [name]="sub.key"
                       class="switch is-rounded is-primary form-control" checked
                       [(ngModel)]="sub.value">
                <label for="{{ sub.key }}" class="label">Value</label>
              </div>

              <div *ngSwitchCase="'string'">
                <label class="label">Value</label>
                <input class="input" type="text" [(ngModel)]="sub.value">
              </div>

            </div>

          </div>
        </div>

      </div>

      <!--      EMPTY OPERATOR-->
      <div *ngIf="sub.key.length == 0" class="column is-2">
      </div>

      <!-- MINUS BUTTON -->
      <div class="column is-1">
        <label class="label"> <br/></label>
        <button class="button is-danger" (click)="removeSubCriteria(newEvaluationCriterias[i],j)">
          <span class="icon"><i class="fas fa-minus"></i></span>
        </button>
      </div>

      <!-- PLUS BUTTON -->

      <div *ngIf="sub.key.length > 0 && isLastSub(newEvaluationCriterias[i],sub)" class="column is-1">
        <label class="label"> <br/></label>

        <button [disabled]="addingAllowed(newEvaluationCriterias[i], i)" class="button is-success"
                (click)="addSubCriteria(newEvaluationCriterias[i])">
          <span class="icon"><i class="fas fa-plus"></i></span>
        </button>
      </div>

      <div class="column is-1" *ngIf="sub.key.length == 0"></div>

      <div class="column is-1" *ngIf="!isLastSub(newEvaluationCriterias[i],sub)"></div>
    </div>


    <!-- END TEMPLATE SUB CRITERIA -->

    <hr>
    <button class="button is-success"
            [disabled]="addingAllowed(newEvaluationCriterias[i], i)"
            (click)="addEvaluatorCriteria(i)">
      <span class="icon"><i class="fas fa-check"></i></span>
      <span>Add</span>
    </button>

  </div>
</div>
